program SI_Console;

{$APPTYPE CONSOLE}

uses
  Classes,
  SysUtils,
  MSI_Console,
  MiTeC_Routines;
var
  SI: TMSI;
begin
  SI:=TMSI.Create([soMachine,soCPU,soOS,soDisplay,soMemory,soMedia,soNetwork,soPrinters]);
  with SI do begin
    Writeln(About);
    writeln;
    write('Gathering information...please wait...');
    try
      Refresh;
      writeLn('OK');
      writeln;
      writeln(Format('Machine: %s (User: %s)',[Machine.Name, Machine.User]));
      writeln(Format('System Up Time: %s',[formatseconds(Machine.SystemUpTime,true,false,False)]));
      writeln(Format('CPU: %s %s - %d Mhz',[CPU.Vendor,
                                            CPU.VendorID,
                                            CPU.Frequency]));
      writeln(Format('Memory: %d MB (%d KB free)',[Memory.PhysicalTotal div 1024 div 1024,Memory.PhysicalFree div 1024]));
      writeln(Format('OS: %s [%d.%d.%d]',[OSVersion,
                                          OS.MajorVersion,
                                          OS.MinorVersion,
                                          OS.BuildNumber]));
      writeln(Format('Video: %s (%d x %d - %d bit)',[Display.Adapter,
                                                     Display.HorzRes,
                                                     Display.VertRes,
                                                     Display.ColorDepth]));
      if Media.Devices.Count>0 then begin
        if Media.SoundCardIndex>-1 then
          writeln(Format('Sound: %s',[Media.Devices[Media.SoundCardIndex]]))
        else
          writeln(Format('Sound: %s',[Media.Devices[0]]));
      end;
      if Network.Adapters.Count>0 then begin
        if Network.CardAdapterIndex>-1 then
          writeln(Format('Network: %s',
                         [Network.Adapters[Network.CardAdapterIndex]]))
        else
          writeln(Format('Network: %s',
                         [Network.Adapters[0]]));
      end;

      writeln(Format('IP Address: %s',[Network.IPAddresses[0]]));
      if Network.MACAddresses.Count>0 then
        writeln(Format('MAC Address: %s',[Network.MACAddresses[0]]));
      if Printers.Names.Count>0 then
        writeln(Format('Printer: %s on %s',[Printers.Names[Printers.DefaultIndex],
                                                      Printers.Ports[Printers.DefaultIndex]]));
    except
      on e: exception do begin
        writeln(e.message);
      end;
    end;
  end;
  writeln;
  writeln('press [enter] to exit...');
  readln;
end.
